#include"global.h"


  /* ------SPCR: SPI Control Rigister-------------
   *
   * SPIE: SPI INterrupt Enable
   * SPE:  SPI Enable
   * DORD: Data Order 1 = LSB 0=MSB
   * MSTR: Master/Slace Select 1 = Master 0 = Slave
   * CPOL: Clock Polarity
   * CPHA: Clock Phase
   * SPR1: SPI Clock Rate Select
   * SPR0: SPI Clock Rate Select
  */


  /*------SPSR: SPI Status Register-------------
   * SPIF:  SPI Interup Flag --> 1 when transfer is complete
   * WCOL:  Write Collision Flag
   * SPI2x: SPI Double Speed Mode
   */


  /*------SPDR: SPI Data Register-------------
   * Bit 7 is MSB Bit 0 is LSB
   */


volatile uint8_t spi_recive_char;
volatile uint8_t is_master;


void spiInitMaster(){

  // SPI enable; master enable; Frequency / 16
  SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0);

  //SET MOSI,SCK, PIN2 as Output
  DDRB = (1<<PINB5)|(1<<PINB3)|(1<<PINB2);
  is_master = true;
}

void spiInitSlave(){
  // SPI enable; SPI Interrupt enabled
  SPCR = (1<<SPIE)|(1<<SPE);

  // Pin 4 as Output
  DDRB = (1<<PB4);
}

// used to trancive data
uint8_t spiTransferData (uint8_t data)
{

    SPDR = data;                       //Load data into the buffer
    while(!(SPSR & (1<<SPIF))){}       //Wait until transmission complete
    return(SPDR);    //Return received data
}

void enableSpi(){
  PORTB &= ~(1<<PB2);
}

void disableSpi(){
  PORTB |= (1<<PB2);
}



// Interrupt Servoce Routine for SPI slaves
ISR(SPI_STC_vect){
  uartSendChar(SPSR);
  spi_recive_char = SPDR;
  uartSendChar(spi_recive_char);
  uartSendChar(SPSR);
}
